part of trober_sdk.api;

// inline_object
class InlineObject {
  String id;
  InlineObject();

  @override
  String toString() {
    return 'InlineObject[id=$id, ]';
  }

  fromJson(Map<String, dynamic> json) {
    if (json == null) return;

    {
      final _jsonData = json[r'id'];
      id = (_jsonData == null) ? null : _jsonData;
    } // _jsonFieldName
  }

  InlineObject.fromJson(Map<String, dynamic> json) {
    fromJson(json); // allows child classes to call
  }

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
    if (id != null) {
      json[r'id'] = LocalApiClient.serialize(id);
    }
    return json;
  }

  static List<InlineObject> listFromJson(List<dynamic> json) {
    return json == null
        ? <InlineObject>[]
        : json.map((value) => InlineObject.fromJson(value)).toList();
  }

  static Map<String, InlineObject> mapFromJson(Map<String, dynamic> json) {
    final map = <String, InlineObject>{};
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic value) =>
          map[key] = InlineObject.fromJson(value));
    }
    return map;
  }

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) {
      return true;
    }

    if (other is InlineObject && runtimeType == other.runtimeType) {
      return id == other.id;
    }

    return false;
  }

  @override
  int get hashCode {
    var hashCode = runtimeType.hashCode;

    if (id != null) {
      hashCode = hashCode ^ id.hashCode;
    }

    return hashCode;
  }

  InlineObject copyWith({
    String id,
  }) {
    InlineObject copy = InlineObject();
    copy.id = id ?? this.id;
    return copy;
  }
}
