part of trober_sdk.api;

enum ShipmentSize { n40sT, n20sT, n40hC, n40hW, custom }

class ShipmentSizeTypeTransformer {
  static Map<String, ShipmentSize> fromJsonMap = {
    "40ST": ShipmentSize.n40sT,
    "20ST": ShipmentSize.n20sT,
    "40HC": ShipmentSize.n40hC,
    "40HW": ShipmentSize.n40hW,
    "Custom": ShipmentSize.custom
  };
  static Map<ShipmentSize, String> toJsonMap = {
    ShipmentSize.n40sT: "40ST",
    ShipmentSize.n20sT: "20ST",
    ShipmentSize.n40hC: "40HC",
    ShipmentSize.n40hW: "40HW",
    ShipmentSize.custom: "Custom"
  };

  static ShipmentSize fromJson(dynamic data) {
    var found = fromJsonMap[data];
    if (found == null) {
      throw ('Unknown enum value to decode: $data');
    }
    return found;
  }

  static dynamic toJson(ShipmentSize data) {
    return toJsonMap[data];
  }

  static List<ShipmentSize> listFromJson(List<dynamic> json) {
    return json == null
        ? <ShipmentSize>[]
        : json.map((value) => fromJson(value)).toList();
  }

  static ShipmentSize copyWith(ShipmentSize instance) {
    return instance;
  }

  static Map<String, ShipmentSize> mapFromJson(Map<String, dynamic> json) {
    final map = <String, ShipmentSize>{};
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic value) => map[key] = fromJson(value));
    }
    return map;
  }
}
