part of trober_sdk.api;

enum ShipmentType { incoming, outGoing }

class ShipmentTypeTypeTransformer {
  static Map<String, ShipmentType> fromJsonMap = {
    "Incoming": ShipmentType.incoming,
    "OutGoing": ShipmentType.outGoing
  };
  static Map<ShipmentType, String> toJsonMap = {
    ShipmentType.incoming: "Incoming",
    ShipmentType.outGoing: "OutGoing"
  };

  static ShipmentType fromJson(dynamic data) {
    var found = fromJsonMap[data];
    if (found == null) {
      throw ('Unknown enum value to decode: $data');
    }
    return found;
  }

  static dynamic toJson(ShipmentType data) {
    return toJsonMap[data];
  }

  static List<ShipmentType> listFromJson(List<dynamic> json) {
    return json == null
        ? <ShipmentType>[]
        : json.map((value) => fromJson(value)).toList();
  }

  static ShipmentType copyWith(ShipmentType instance) {
    return instance;
  }

  static Map<String, ShipmentType> mapFromJson(Map<String, dynamic> json) {
    final map = <String, ShipmentType>{};
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic value) => map[key] = fromJson(value));
    }
    return map;
  }
}
